/**
 * @file usr_color.h
 * @brief J[֘Å֐
 */
//---------------------------------------------------------------------------
#ifndef UsrColorH
#define UsrColorH

//---------------------------------------------------------------------------
extern const TColor col_None;
extern const TColor col_Teal;

//---------------------------------------------------------------------------
/**
 * @brief Px擾
 * @param col ΏېF
 * @return double Pxl(0`1.0)
 */
double GetLuminance(TColor col);

/**
 * @brief Fɔ{
 * @param col ̐F
 * @param rt {(0.0`1.0)
 * @return TColor 
 */
TColor RatioCol(TColor col, float rt);

/**
 * @brief PxɊÂăO[XP[
 * @param col ̐F
 * @return TColor O[XP[ꂽF
 */
TColor GrayCol(TColor col);

/**
 * @brief F擾
 * @param col ̐F
 * @return TColor F
 */
TColor ComplementaryCol(TColor col);

/** @brief RGBHSL ϊ */
void RgbToHsl(TColor col, int *h, int *s, int *l);

/** @brief RGBHSV ϊ */
void RgbToHsv(TColor col, int *h, int *s, int *v);

/** @brief RGBHSV ϊ */
void RgbToHsv(BYTE r, BYTE g, BYTE b, int *h, int *s, int *v);

/** @brief HSLRGB ϊ */
TColor HslToCol(int h, int s, int l);

/**
 * @brief wi̋Px甒܂͍IE
 * @param col wiF
 * @param rt w
 * @return TColor 
 */
TColor SelectWorB(TColor col, float rt = 1.0);

#define ADJCOL_FGLIST	96
#define ADJCOL_LIGHT	72
#define ADJCOL_BGMID	64
#define ADJCOL_BGLTL	48
#define ADJCOL_BGINV	32
#define ADJCOL_BGBIT	16

/**
 * @brief PxɊÂĖÂ
 * @param col ̐F
 * @param adj l (0`255)
 * @return TColor 
 */
TColor AdjustColor(TColor col, int adj);

/** @brief QF */
TColor Mix2Colors(TColor col1, TColor col2);

/**
 * @brief 񂩂J[ݒ
 * @param[out] col 
 * @param s l\
 */
void str_to_Color(TColor &col, UnicodeString s);

/**
 * @brief X^ClEBhEwiF̎擾
 * @param is_inv ȍ
 * @return TColor 
 */
TColor get_WinColor(bool is_inv = false);

/**
 * @brief X^ClEBhEF̎擾
 * @param is_hl nCCg
 * @return TColor 
 */
TColor get_TextColor(bool is_hl = false);

/**
 * @brief X^ClplF̎擾
 * @param is_inv ȍ
 * @return TColor 
 */
TColor get_PanelColor(bool is_inv = false);

/**
 * @brief X^ClxF̎擾
 * @param is_inv ȍ
 * @return TColor 
 */
TColor get_LabelColor(bool is_inv = false);

void set_EditColor(TEdit *ep, bool is_inv = false);
void set_EditColor(TLabeledEdit *ep, bool is_inv = false);
void set_EditColor(TMaskEdit *ep, bool is_inv = false);
void InvColIfEmpty(TLabeledEdit *ep);
void InvColIfEmpty(TEdit *ep);

TColor get_OptSysColor(TColor col, TColor def);

/**
 * @brief nCCgF̐ݒ
 * @param cv LoX
 * @param hl nCCg
 */
void SetHighlight(TCanvas *cv, bool hl);

//---------------------------------------------------------------------------
#endif
