/**
 * @file usr_tag.h
 * @brief ^OǗjbg
 */
//---------------------------------------------------------------------------
#ifndef UsrTagManagerH
#define UsrTagManagerH

//---------------------------------------------------------------------------
#include <Vcl.CheckLst.hpp>
#include "usr_str.h"

//---------------------------------------------------------------------------
/**
 * @brief ^OǗjbg
 */
class TagManager
{
private:
	TDateTime TagDataTime;		//݂̃^CX^v
	bool Modified;

	TColor DefColor;			//ftHg̃^OF

	int  GetIndex(UnicodeString fnam);
	void MakeTagNameList();

	UnicodeString GetDataTags(int idx)
	{
		return (idx!=-1)? get_post_tab(TagDataList->Strings[idx]) : EmptyStr;
	}

	UnicodeString GetDataTags(int idx, UnicodeString &fnam)
	{
		if (idx==-1) return EmptyStr;

		UnicodeString ret_str = TagDataList->Strings[idx];
		fnam = split_pre_tab(ret_str);
		return ret_str;
	}

public:
	UnicodeString FileName;
	bool SortTags;

	TStringList *TagNameList;
	TStringList *TagDataList;
	TStringList *TagColList;

	TMultiReadExclusiveWriteSynchronizer *TagRWLock;	//!< TagDataList ̕یp

	TagManager(UnicodeString fnam);
	~TagManager();

	bool UpdateFile();		//!< t@CXV
	bool Recycle();			//!< ^CX^vωĂēǂݍ
	int  TrimData();		//!< ݂Ȃڂ̃^Of[^𐮗

	UnicodeString GetTags(UnicodeString fnam);							//!< wt@C̃^O擾
	UnicodeString NormTags(UnicodeString tags, bool sw_add = true);
	void DelItem(UnicodeString fnam);									//!< wt@C̃^O폜
	void SetTags(UnicodeString fnam, UnicodeString tags);				//!< wt@CɃ^Oݒ
	void AddTags(UnicodeString fnam, UnicodeString tags);				//!< wt@CɃ^Oǉ
	void Rename(UnicodeString old_nam, UnicodeString new_nam);			//!< t@C/fBNg̕ύX
	void Copy(UnicodeString from_nam, UnicodeString to_nam);			//!< ^ÕRs[
	int  RenTag(UnicodeString old_tag, UnicodeString new_tag);			//!< ^Ỏ
	int  DelTagData(UnicodeString tag);									//!< ^Of[^̍폜

	int IniCheckList(TCheckListBox *lp, UnicodeString tnam = EmptyStr, bool count_sw = false);
	UnicodeString CheckToTags(TCheckListBox *lp, UnicodeString tags);
	void CountTags(TCheckListBox *lp, bool clr_sw = false);

	/**
	 * @brief w^OɃ}b`郊Xg擾
	 * @param tags ^O
	 * @param and_sw AND
	 * @param[out] lst Xg
	 * @return int }b`
	 */
	int  GetMatchList(UnicodeString tags, bool and_sw, TStringList *lst);

	/**
	 * @brief ׂẴ^Oڂ̃Xg擾
	 * @param[out] lst Xg
	 * @return int
	 */
	int  GetAllList(TStringList *lst);

	/** @brief t@CɃ^OtĂ邩H */
	bool HasTag(UnicodeString fnam);

	/**
	 * @brief t@Cw^OɃ}b`邩H
	 * @param fnam t@C
	 * @param ktags ^O
	 * @param and_sw AND
	 * @return true
	 * @return false
	 */
	bool Match(UnicodeString fnam, UnicodeString ktags, bool and_sw);

	/**
	 * @brief ^OF擾
	 * @param tag ^O
	 * @param col_def ftHgF
	 * @return TColor
	 */
	TColor GetColor(UnicodeString tag, TColor col_def);

	/**
	 * @brief ^OFݒ
	 * @param tag ^O
	 * @param col F
	 */
	void SetColor(UnicodeString tag, TColor col);

	/**
	 * @brief ^O̕`
	 * @param tags ^O
	 * @param cv LoX
	 * @param x Xʒu
	 * @param y Yʒu
	 * @param col_rev wwiFŔ]\
	 * @param blk_sw ubNL\
	 */
	void DrawTags(UnicodeString tags, TCanvas *cv, int x, int y, TColor col_rev = Graphics::clNone, bool blk_sw = false);
};
//---------------------------------------------------------------------------
extern TagManager *usr_TAG;
//---------------------------------------------------------------------------
#endif
